#include <stdint.h>
#include <stdlib.h>
#include "softintr.h"
#include "core_cm0.h"

extern "C" {
 void __cxa_pure_virtual (void) {
   // neni potreba - byla by jen chybova hlaska.
 }
  extern void SOFT_IRQHandler (void);
  extern void SFT0_IRQHandler (void);
  extern void SFT1_IRQHandler (void);
}

static const IRQn_Type CSoftTable [MaxSoftIntrs] = {
  SOFT_IRQn, SFT0_IRQn, SFT1_IRQn
};
static SoftIntr   *    ISoftTable [MaxSoftIntrs];

SoftIntr::SoftIntr (const SoftIntrNumber n) : N(CSoftTable [n]) {
  ISoftTable [n] = this;
  NVIC_EnableIRQ   (N);
  NVIC_SetPriority (N, 1);      // priority 1..3, nižší než nadřízené
}
void SoftIntr::exec (void) {
  if (!NVIC_GetPendingIRQ (N))  // to je sice zbytečné, ale nezdržuje to
       NVIC_SetPendingIRQ (N);
}
void SOFT_IRQHandler (void) {
  SoftIntr * Instance = ISoftTable [0];
  if (Instance) Instance->run();
}
void SFT0_IRQHandler (void) {
  SoftIntr * Instance = ISoftTable [1];
  if (Instance) Instance->run();
}
void SFT1_IRQHandler (void) {
  SoftIntr * Instance = ISoftTable [2];
  if (Instance) Instance->run();
}

